A clobber was surrounded by braces in the `llvm_asm` macro.

Erroneous code example:

```compile_fail,E0664
llvm_asm!("mov $$0x200, %eax"
          :
          :
          : "{eax}"
         );
```

Considering that this would be a long explanation, we instead recommend you
take a look at the [`llvm_asm`] chapter of the Unstable book:

[`llvm_asm`]: https://doc.rust-lang.org/stable/unstable-book/library-features/llvm-asm.html
